# Supports Organizer.rb
=begin rdoc
= YZ + X
Copyright 2009, Chris Fullmer
All Rights Reserved

== Disclaimer
THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.

== License
This software is distributed under the Smustard End User License Agreement
http://www.smustard.com/eula

== Information
Author:: Chris Fullmer
Organization:: www.ChrisFullmer.com and distributed on www.sketchucation.com
Name:: YZ + X
Version:: v1.0
SU Version:: Developed on SU 7, should be compatible with 6 and 5 at least.
Date:: November 29th, 2009
Description:: This script takes 2 points and uses the first one's Y and Z position, and the second one's X position and adds a cpoint at the new point.
Usage:: Plugins > Chris Fullmer Tools > YZ + X.  Select the first point, then the 2nd.  It will add a construction point.  This plujgins does not work right if the model axis has been altered.  So reset the model axis first - sorry!
History::
1.0:: 2009-11-29
   * First release
=end

class Clf_yz_x

	def activate
		@pt1 = []
		@pt2 = []
		@status = "Select Point 1 - YZ"
		Sketchup.status_text = @status
	end
	
	def resume(view)
		Sketchup.status_text = @status
	end

	def make_pt
		cpt = Geom::Point3d.new( @pt2[0], @pt1[1], @pt1[2] )
		model = Sketchup.active_model
		model.start_operation "YZ + X"
		model.active_entities.add_cpoint cpt
		model.commit_operation
		@pt1 = []
		@pt2 = []
		@status = "Select Point 1 - YZ"
		Sketchup.status_text = @status
	end
	
	def onLButtonUp(flags, x, y, view)
		my_ip = view.inputpoint x, y
		my_vert = my_ip.vertex
		if my_vert
			if @pt1.is_a? Array
				@pt1 = my_vert.position
				@status = "Select Point 2 - X"
				Sketchup.status_text = @status
			else
				@pt2 = my_vert.position
				make_pt
			end
		end
	end




end


#------Menu System---------------------------
if( $submenu )
	organizer = $submenu 
	if !file_loaded?(__FILE__)
		organizer.add_item("YZ + X") { Sketchup.active_model.select_tool Clf_yz_x.new  }
	end
else
	if !file_loaded?('clf_menu_loader')
		$clf_tools_menu = UI.menu("Plugins").add_submenu("Chris Fullmer Tools")
	end
	#------New menu Items---------------------------
	#if !file_loaded?('clf_youtube_loader')
	#	$clf_youtube_menu = $clf_tools_menu.add_submenu("-=YouTube Video Tutorials For My Scripts=-")
	#	$clf_youtube_menu.add_item("My YouTube Channel"){UI.openURL "http://www.youtube.com/user/ChrisFullmer"}
	#end
	if !file_loaded?('clf_myscipts_loader')
		$clf_tools_menu.add_item("-=All My Plugins I've Written=-"){UI.openURL "http://forums.sketchucation.com/search.php?keywords=plugin&terms=all&author=Chris+Fullmer&sc=1&sf=titleonly&sr=topics&sk=t&sd=d&st=0&ch=300&t=0&submit=Search"}
	end
	#------YouTube for this Script------------------
	#$clf_youtube_menu.add_item("Component Stringer Video"){UI.openURL "http://www.chrisfullmer.com/plugins/clf_component_stringer.html"}		
	#------Donate to the Author--------------------
	if !file_loaded?('clf_paypal_loader')
		$clf_tools_menu.add_item("-=Donate $$$ to Chris via PayPal=-"){UI.openURL "http://www.chrisfullmer.com/plugins/donate.html"}
		$clf_tools_menu.add_separator
	end
	#------------------------------------------------
	
	if !file_loaded?(__FILE__)
		$clf_tools_menu.add_item("YZ + X") { Sketchup.active_model.select_tool Clf_yz_x.new }
	end
end

file_loaded('clf_myscipts_loader')
file_loaded('clf_paypal_loader')
file_loaded('clf_youtube_loader')
file_loaded('clf_menu_loader')
file_loaded(__FILE__)